#define __OCICPP_INTERNAL_USE_
#include "OraType.h"

OraType::OraType(OCIEnv *envhp,OCIError *errhp,OCIParam *paramd,ub2 type): 
	definehp(0),env(envhp),err(errhp),null(-1) 
{
	char *tmpColName;
	text *colName;
	ub4 colNameLen;
	internalType=type;
	CHECKERR(errhp,OCIAttrGet((dvoid *) paramd,OCI_DTYPE_PARAM,(dvoid **) &colName,(ub4 *) &colNameLen,(ub4) OCI_ATTR_NAME,errhp));
	tmpColName=(char *)calloc(colNameLen+1,sizeof(char));
	for(unsigned i=0;i<colNameLen;i++) tmpColName[i]=colName[i];
	DEBUG(DLEV_DEBUG,"colName=%s\n",tmpColName);
	attrName.assign(tmpColName);
	free(tmpColName);
	setTypeName();
	DEBUG(DLEV_DEBUG,"ColNameLen=%d AttrName=%s TypeName=%s\n",(int)colNameLen,attrName.c_str(),typeName.c_str());
}

OraType::~OraType()
{
}

void OraType::setTypeName() {
	switch(internalType) {
		case SQLT_CHR:
			typeName.assign("VARCHAR2");
			break;
		case SQLT_NUM:
			typeName.assign("NUMBER");
			break;
		case SQLT_LNG:
			typeName.assign("LONG");
			break;
		case SQLT_RDD:
		case SQLT_RID:
			typeName.assign("ROWID");
			break;
		case SQLT_DAT:
			typeName.assign("DATE");
			break;
		case SQLT_BIN:
			typeName.assign("RAW");
			break;
		case SQLT_LBI:
			typeName.assign("LONG RAW");
			break;
		case SQLT_AFC:
			typeName.assign("CHAR");
			break;
		case SQLT_LAB:
			typeName.assign("MLSLABEL");
			break;
		case SQLT_REF:
			typeName.assign("REF");
			break;
		case SQLT_CLOB:
			typeName.assign("CLOB");
			break;
		case SQLT_BLOB:
			typeName.assign("BLOB");
			break;
		default:
			typeName.assign("Unknown");
			break;
	}
}

unsigned OraType::getSize() const {
	return size;
}

int OraType::getType() const {
	return (int)internalType;
}

int OraType::getReqType() const {
	return (int)ReqType;
}

void OraType::getTypeName(string &tname) const {
	tname.assign(typeName);
}

void OraType::getAttrName(string &aname) const {
	aname.assign(attrName);
}

int OraType::isNull() const {
	return (null==-1)?1:0;
}

